#include "utils.h"
#include "pthread_wrappers.h"

const uint64_t N_THREADS = 100;

typedef struct id_s {
    uint64_t           id;
    volatile uint64_t* token;
} id_t;

void*
worker(void* arg)
{
    id_t* frame = (id_t*) arg;

    while ( *frame->token != frame->id)
        ; // active waiting

    printf("[%lu]\tI have the token!\n", frame->id);

    (void) __sync_fetch_and_add(frame->token, 1);

    return NULL;
}


int
main(void)
{
    pthread_t         threads [N_THREADS];
    id_t              ids     [N_THREADS];
    volatile uint64_t token = 0;

    for (uint64_t i = 0; i < N_THREADS; ++i) {
        ids[i] = (id_t){ .id = i, .token = &token };
        spthread_create(&threads[i], NULL, worker, &ids[i]);
    }

    for (uint64_t i = 0; i < N_THREADS; ++i) 
        spthread_join(threads[i],NULL);

    return 0;
}
